﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace DropDownList_EntityFramework_MVC.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            List<SelectListItem> customerList = GetCustomers();
            return View(customerList);
        }

        [HttpPost]
        public ActionResult Index(string ddlCustomers)
        {
            List<SelectListItem> customerList = GetCustomers();
            if (!string.IsNullOrEmpty(ddlCustomers))
            {
                SelectListItem selectedItem = customerList.Find(p => p.Value == ddlCustomers);
                ViewBag.Message = "Name: " + selectedItem.Text;
                ViewBag.Message += "\\nID: " + selectedItem.Value;
            }
            return View(customerList);
        }

        private static List<SelectListItem> GetCustomers()
        {
            CustomersEntities entities = new CustomersEntities();
            List<SelectListItem> customerList = (from p in entities.Customers.AsEnumerable()
                                                 select new SelectListItem
                                                 {
                                                     Text = p.Name,
                                                     Value = p.CustomerId.ToString()
                                                 }).ToList();


            //Add Default Item at First Position.
            customerList.Insert(0, new SelectListItem { Text = "--Select Customer--", Value = "" });
            return customerList;
        }
    }
}